import 'package:dio/dio.dart';

abstract class DioExceptions {
  String dioErrorTypeCancel = "Запрос к серверу API был отменен";
  String dioErrorTypeConnectTimeout = "Время соединения с сервером истекло";
  String dioErrorTypeOther = "connection_error";
  String dioErrorTypeReceiveTimeout =
      "Время получения в связи с сервером истекло";
  String dioErrorTypeSendTimeout = "Время отправки в связи с сервером истекло";
  String dioErrorTypeMore = "Что-то пошло не так";

  String fromDioError(DioError dioError) {
    switch (dioError.type) {
      case DioErrorType.cancel:
        message = dioErrorTypeCancel;
        break;
      case DioErrorType.connectTimeout:
        message = dioErrorTypeConnectTimeout;
        break;
      case DioErrorType.other:
        message = dioErrorTypeOther;
        break;
      case DioErrorType.receiveTimeout:
        message = dioErrorTypeReceiveTimeout;
        break;
      case DioErrorType.response:
        message =
            handleError(dioError.response?.statusCode, dioError.response?.data);
        break;
      case DioErrorType.sendTimeout:
        message = dioErrorTypeSendTimeout;
        break;
      default:
        message = dioErrorTypeMore;
        break;
    }
    return message;
  }

  late String message = "Произошла ошибка";

  String handleError(int? statusCode, dynamic error) {
    switch (statusCode) {
      case 400:
        return 'Неверный запрос';
      case 404:
        return error["message"] ?? error['text'] ?? error;
      case 500:
        return 'Внутренняя ошибка сервера';
      default:
        return 'Упс! Что-то пошло не так';
    }
  }
}
